import { IAbreviationTraductor, IConsoleParser } from './interfaces';
import { IPseudo } from './interfaces';
import { ValuesSingleton } from './singletons/valuesSingleton';
import * as i0 from "@angular/core";
export declare class NgxBootstrapExpandedFeaturesService {
    values: ValuesSingleton;
    indicatorClass: string;
    colors: {
        [key: string]: string;
    };
    abreviationsClasses: {
        [key: string]: string;
    };
    abreviationsValues: {
        [key: string]: string;
    };
    combos: {
        [key: string]: string[];
    };
    combosCreated: {
        [key: string]: string;
    };
    encryptCombo: boolean;
    encryptComboCharacters: string;
    encryptComboCreatedCharacters: string;
    cssNamesParsed: any;
    alreadyCreatedClasses: string[];
    sheet: any;
    isDebug: boolean;
    bps: any;
    bpsSpecifyOptions: string[];
    limitBPS: boolean;
    styleSheetToManage: string;
    separator: string;
    styleConsole: string;
    pseudoClasses: string[];
    pseudosHasSDED: string[];
    pseudoElements: string[];
    pseudos: IPseudo[];
    importantActive: boolean;
    abreviationTraductors: IAbreviationTraductor[];
    lastCSSCreate: number;
    lastTimeAsked2Create: number;
    timesCSSCreated: number;
    timeBetweenReCreate: number;
    useTimer: boolean;
    constructor();
    checkSheet: () => void;
    cssCreate: (updateBefs?: string[] | null, primordial?: boolean) => void;
    createCSSRules: (rule: string) => void;
    colorToRGB: (color: string) => number[];
    RGBToRGBA: (rgb: number[], alpha: number) => string;
    parseRGB: (rgba: string) => number[];
    HexToRGB: (Hex: string) => string;
    HSLToRGB: (HSL: string) => string;
    HWBToRGB: (HWB: string) => string;
    shadeTintColor: (rgb: number[], percent: number) => number[];
    cssValidToCamel: (st: string) => string;
    camelToCSSValid: (st: string) => string;
    pushCssNamesParsed: (cssNamesParsed: any) => void;
    pushBPS: (bps: any) => void;
    pushColors: (newColors: any) => void;
    pushAbreviationsValues: (abreviationsValues: any) => void;
    pushAbreviationsClasses: (abreviationsClasses: any) => void;
    pushCombos: (combos: any) => void;
    getColors: () => any;
    getBPS: () => import("./interfaces").IBPS[];
    getAbreviationsValues: () => any;
    getAbreviationsClasses: () => any;
    getCombos: () => any;
    getCssNamesParsed: () => any;
    getColorsNames: () => string[];
    getColorValue: (color: string) => any;
    getAlreadyCreatedClasses: () => string[];
    getSheet: () => CSSStyleSheet | undefined;
    updateColor: (color: string, value: string) => void;
    updateAbreviationsClass: (abreviationsClass: string, value: string) => void;
    updateAbreviationsValue: (abreviationsValue: string, value: string) => void;
    updateCombo: (combo: string, values: string[]) => void;
    updateCssNamesParsed: (cssNameParsed: string, value: string) => void;
    updateClasses: (classesToUpdate: string[]) => void;
    deleteColor: (color: string) => void;
    clearAllColors: () => void;
    changeImportantActive: (active: boolean) => void;
    changeDebugOption: (active?: boolean) => void;
    changeUseTimerOption: (active?: boolean) => void;
    setTimeBetweenReCreate: (time: number) => void;
    unbefysize: (value: string) => string;
    befysize: (value: string) => string;
    consoleLog: (type: "log" | "info" | "trace" | "error" | undefined, thing: any, style?: string, line?: string | null, stoper?: boolean) => void;
    consoleParser: (config: IConsoleParser) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxBootstrapExpandedFeaturesService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NgxBootstrapExpandedFeaturesService>;
}
